---
title: Writing style guide
slug: MDN/Guidelines/Writing_style_guide
tags:
  - Documentation
  - Guide
  - Guidelines
  - MDN
  - MDN Meta
  - MDN Web Docs
  - MDN style guide
  - Style guide
  - Writing style guide
---
<div>{{MDNSidebar}}</div>

<p><span class="seoSummary">To present documentation in an organized, standardized, and easy-to-read manner, the MDN Web Docs style guide describes how text should be organized, spelled, formatted, and so on. These are guidelines rather than strict rules.</span> We are more interested in content than formatting, so don't feel obligated to learn the style guide before contributing. Do not be upset or surprised, however, if an industrious volunteer later edits your work to conform to this guide.</p>

<p>The language aspects of this guide apply primarily to English-language documentation. Other languages may have (and are welcome to create) style guides. These should be published as subpages of the localization team's page.</p>

<p>For style standards that apply to content written for sites other than MDN, refer to the <a href="https://www.mozilla.org/en-US/styleguide/">One Mozilla style guide</a>.</p>

<h2 id="Basics">Basics</h2>

<p>The best place to start in any extensive publishing style guide is with some very basic text standards to help keep documentation consistent. The following sections outline some of these basics to help you.</p>

<h3 id="Page_titles">Page titles</h3>

<p>Page titles are used in search results and are also used to structure the page hierarchy in the breadcrumb list at the top of the page. The page title (which is displayed at the top of the page and in the search results) can be different from the page "slug", which is the portion of the page's URL following "<code><var>&lt;locale&gt;</var>/docs/</code>".</p>

<h4 id="Title_and_heading_capitalization">Title and heading capitalization</h4>

<p>Page titles and section headings should use sentence-style capitalization (only capitalize the first word and proper nouns) rather than headline-style capitalization:</p>

<ul>
 <li><span class="correct"><strong>Correct</strong></span>: "A new method for creating JavaScript rollovers"</li>
 <li><span class="incorrect"><strong>Incorrect</strong></span>: "A New Method for Creating JavaScript Rollovers"</li>
</ul>

<p>We have many older pages that were written before this style rule was established. Feel free to update them as needed if you like. We're gradually getting to them.</p>

<h4 id="Choosing_titles_and_slugs">Choosing titles and slugs</h4>

<p>Page slugs should be kept short. When creating a new level of hierarchy, the new level's component in the slug should just be a word or two.</p>

<p>Page titles, on the other hand, may be as long as you like, within reason, and they should be descriptive.</p>

<h4 id="Creating_new_subtrees">Creating new subtrees</h4>

<p>When you need to add some articles about a topic or subject area, you will typically do so by creating a landing page, then adding subpages for each of the individual articles. The landing page should open with a paragraph or two describing the topic or technology, then provide a list of the subpages with descriptions of each page. You can automate the insertion of pages into the list using some macros we've created.</p>

<p>For example, consider the <a href="/en-US/docs/Web/JavaScript">JavaScript</a> guide, which is structured as follows:</p>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Guide" title="JavaScript/Guide">JavaScript/Guide</a> – Main table-of-contents page</li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/JavaScript_Overview" title="JavaScript/Guide/JavaScript_Overview">JavaScript/Guide/JavaScript Overview</a></li>
 <li><a href="/en-US/docs/JavaScript/Guide/Functions" title="JavaScript/Guide/Functions">JavaScript/Guide/Functions</a></li>
 <li><a href="/en-US/docs/JavaScript/Guide/Details_of_the_Object_Model" title="JavaScript/Guide/Details_of_the_Object_Model">JavaScript/Guide/Details of the Object Model</a></li>
</ul>

<p>Try to avoid putting your article at the top of the hierarchy, which slows the site down and makes search and site navigation less effective.</p>

<div class="notecard note">
<p><strong>Note:</strong> Adding articles requires <a href="/en-US/docs/MDN/Contribute/Howto/Create_and_edit_pages#Getting_page-creation_permissions">page creation privileges</a>.</p>
</div>

<h3 id="General_article_content_guidelines">General article content guidelines</h3>

<p>When writing any document, it's important to know how much to say. If you ramble on too long, or provide excessive detail, the article becomes tedious to read and it will rarely be used. Getting the amount of coverage right is important for several reasons. Among those reasons: ensure that the reader finds the information they truly need, and provide enough quality material for search engines to adequately analyze and rank the article.</p>

<p>We'll discuss the former (providing the information the reader may need) here. To learn more about ensuring that pages are properly classified and ranked by search engines, see the article <a href="/en-US/docs/MDN/Contribute/Howto/Write_for_SEO">How to write for SEO on MDN</a>.</p>

<p>The goal is to write pages that include all the information that readers may need without going into too much details. Following are some recommendations in this area.</p>

<h4 id="Consider_your_audience">Consider your audience</h4>

<p>Keep in mind that these are guidelines. Some of these tips may not apply in every case. Certainly keep your article's audience in mind. For example, article on advanced network techniques likely doesn't need to go into as much detail about basic networking concepts as the typical article on networking.</p>

<h4 id="Provide_a_useful_summary">Provide a useful summary</h4>

<p>Make sure the article's summary—that is, the opening paragraph or paragraphs before the first heading—provides enough information for the readers to understand if the article is likely to be covering what they're interested in reading about.</p>

<p>In a guide or tutorial content, the summary should let the reader know what topics will be covered and what they're already expected to know, if anything. It should mention the technologies and/or APIs that are being documented or discussed, with links to related information, and it should offer hints to situations in which the article's contents might be useful.</p>

<h5 id="Example_Too_short!">Example: Too short!</h5>

<p>This example of a summary is far too short. It leaves out too much information, such as what it means exactly to "stroke" text, where the text is drawn, and so forth.</p>

<div class="example-bad">
<p><strong><code>CanvasRenderingContext2D.strokeText()</code></strong> draws a string.</p>
</div>

<h5 id="Example_Too_long!">Example: Too long!</h5>

<p>Here, we've updated the summary, but now it's far too long. Too much details are included, and the text gets far too much into describing other methods and properties.</p>

<p>Instead, the summary should focus on the <code>strokeText()</code> method, and should refer to the appropriate guides where the other details are described.</p>

<div class="example-bad">
<p>When called, the Canvas 2D API method <strong><code>CanvasRenderingContext2D.strokeText()</code></strong> strokes the characters in the specified string beginning at the coordinates specified, using the current pen color. In the terminology of computer graphics, "stroking" text means to draw the outlines of the glyphs in the string without filling in the contents of each character with color.</p>

<p>The text is drawn using the context's current font as specified in the context's {{domxref("CanvasRenderingContext2D.font", "font")}} property.</p>

<p>The placement of the text relative to the specified coordinates are determined by the context's <code>textAlign</code>, <code>textBaseline</code>, and <code>direction</code> properties. <code>textAlign</code> controls the placement of the string relative to the X coordinate specified; if the value is <code>"center"</code>, then the string is drawn starting at <code>x - (stringWidth / 2)</code>, placing the specified X-coordinate in the middle of the string. If the value is <code>"left"</code>, the string is drawn starting at the specified value of <code>x</code>. And if <code>textAlign</code> is <code>"right"</code>, the text is drawn such that it ends at the specified X-coordinate.</p>

<p>(etc etc etc...)</p>

<p>You can, optionally, provide a fourth parameter that lets you specify a maximum width for the string, in pixels. If you provide this parameter, the text is compressed horizontally or scaled (or otherwise adjusted) to fit inside a space that wide when being drawn.</p>

<p>You can call the <strong><code>fillText()</code></strong> method to draw a string's characters as filled with color instead of only drawing the outlines of the characters.</p>
</div>

<h5 id="Example_Much_better!">Example: Much better!</h5>

<p>Here we see a much better overview for the <code>strokeText()</code> method.</p>

<div class="example-good">
<p>The {{domxref("CanvasRenderingContext2D")}} method <code><strong>strokeText()</strong></code>, part of the <a href="/en-US/docs/Web/API/Canvas_API">Canvas 2D API</a>, strokes—that is, draws the outlines of—the characters of a specified string, anchored at the position indicated by the given X and Y coordinates. The text is drawn using the context's current {{domxref("CanvasRenderingContext2D.font", "font")}}, and is justified and aligned according to the {{domxref("CanvasRenderingContext2D.textAlign", "textAlign")}}, {{domxref("CanvasRenderingContext2D.textBaseline", "textBaseline")}}, and {{domxref("CanvasRenderingContext2D.direction", "direction")}} properties.</p>

<p>For more details and further examples, see {{SectionOnPage("/en-US/docs/Learn/JavaScript/Client-side_web_APIs/Drawing_graphics", "Text")}} in the Learning Area as well as our main article on the subject, <a href="/en-US/docs/Web/API/Canvas_API/Tutorial/Drawing_text">Drawing text</a>.</p>
</div>

<h4 id="Include_all_relevant_examples">Include all relevant examples</h4>

<p>It's important to ensure that you use examples to clarify what every parameter is used for, and to clarify any edge cases that may exist. You should also use examples to demonstrate solutions for common tasks, and you should use examples to demonstrate solutions to problems that may arise.</p>

<p>In general it is expected that most of the pages will include examples, and that most of them will include more than one example.</p>

<p>Each example should be preceded by text explaining what the example does and anything the reader should know before beginning to read or try out the example.</p>

<h5 id="Code_Examples">Code Examples</h5>

<p>Each piece of code should include an explanation of how it works. Keep in mind that it may make sense to break up a large piece of code into smaller portions so they can be described individually.</p>

<p>The text following each piece of code should explain anything relevant, using an appropriate level of detail:</p>

<ul>
 <li>If the code is very simple and doesn't really use directly anything related to the API being documented, you may only give a quick summary of what it is and why it's there.</li>
 <li>If the code is intricate, uses the API being documented, or is technically creative, you should provide a more detailed explanation.</li>
</ul>

<p>When using the live sample system, it's helpful to be aware that all of the {{HTMLElement("pre")}} blocks in the area that contains the sample are concatenated together before running the example, which lets you break any or all of the HTML, CSS, and JavaScript into multiple segments, each optionally with its own descriptions, headings, and so forth. This makes documenting code incredibly powerful and flexible.</p>

<h4 id="Overly-short_articles_are_hard_to_find">Overly-short articles are hard to find</h4>

<p>If an article is "thin"—that is, too short—it may not be indexed properly (or at all) by search engines. As a rule of thumb, the article's body text should be at least 250–300 words. Don't artificially inflate a page, but treat this guideline as a minimum target length when possible.</p>

<h3 id="Sections_paragraphs_and_newlines">Sections, paragraphs, and newlines</h3>

<p>The <kbd>Enter</kbd> (or <kbd>Return</kbd>) key on your keyboard starts a new paragraph. To insert a newline, rather than a new paragraph (that is, to create a {{HTMLElement("br")}} instead of a {{HTMLElement("p")}}), hold down the <kbd>Shift</kbd> key while pressing <kbd>Enter</kbd>.</p>

<p>When a new paragraph starts a new section, a header should be added.  Use heading levels in decreasing order: {{HTMLElement("h2")}} then {{HTMLElement("h3")}} then {{HTMLElement("h4")}}, without skipping levels.</p>

<p>H2 is the highest level allowed because H1 is reserved for the page title. If you need more than three or four levels of headers, consider breaking up the article into several smaller articles with a landing page, and linking them together using the following macros: {{TemplateLink("Next")}}, {{TemplateLink("Previous")}}, and {{TemplateLink("PreviousNext")}}.</p>

<h4 id="Heading_dos_and_donts">Heading dos and donts</h4>

<ul>
 <li><strong>Don't create single subsections.</strong> Don't subdivide a topic into a single subtopic. It's either two subheadings or more, or none at all.</li>
 <li><strong>Don't use styles and classes within headings.</strong> This includes the {{HTMLElement("code")}} element for code terms. So don't make a heading "Using the <code>SuperAmazingThing</code> interface". It should instead just be "Using the SuperAmazingThing interface".</li>
 <li><strong>Avoid using macros within headings</strong> (except for certain macros that are especifically designed to be used in headings).</li>
 <li><strong>Don't create "bumping heads."</strong> These are headings followed immediately by a subheading, with no content text in between. This doesn't look good, and leaves readers without any explanatory text at the beginning of the outer section.</li>
</ul>

<h3 id="Lists">Lists</h3>

<p>Lists should be formatted and structured uniformly across all pages. Individual list items should be written with suitable punctuation, regardless of the list format. However, depending on the type of the list you are creating, you will want to adjust your writing as described in the sections below.</p>

<h4 id="Bulleted_lists">Bulleted lists</h4>

<p>Bulleted lists should be used to group related pieces of concise information. Each item in the list should follow a similar sentence structure. Phrases and sentences in bulleted lists should include standard punctuation. A period must appear at the end of each sentence in a bulleted list, including the item's final sentence, just as would be expected in a paragraph.</p>

<p>An example of a correctly structured bulleted list:</p>

<div class="example-good">
<p>In this example we should include:</p>

<ul>
 <li>A condition, with a brief explanation.</li>
 <li>A similar condition, with a brief explanation.</li>
 <li>Yet another condition, with some further explanation.</li>
</ul>
</div>

<p>Note how the same sentence structure repeats from bullet to bullet. In this example, each bullet point states a condition followed by a comma and a brief explanation, and each item in the list ends with a period.</p>

<h4 id="Numbered_lists">Numbered lists</h4>

<p>Numbered lists are used primarily to enumerate steps in a set of instructions. Because instructions can be complex, clarity is a priority, especially if the text in each list item is lengthy. As with bulleted lists, follow standard punctuation usage.</p>

<p>An example of a correctly structured numbered list:</p>

<div class="example-good">
<p>In order to correctly structure a numbered list, you should:</p>

<ol>
 <li>Open with a heading or brief paragraph to introduce the instructions. It's important to provide the user with context before beginning the instructions.</li>
 <li>Start creating your instructions, and keep each step in its own numbered item. Your instructions may be quite extensive, so it is important to write clearly and use correct punctuation.</li>
 <li>After you have finished your instructions, follow the numbered list with a brief closing summary or explanation about the expected outcome upon completion.</li>
</ol>

<p>This is an example of writing a closing explanation. We have created a short numbered list that provides instructive steps to produce a numbered list with the correct formatting.</p>
</div>

<p>Note how the items in numbered lists read like short paragraphs. Because numbered lists are routinely used for instructional purposes, or to walk someone through an orderly procedure, be sure to keep each item focused: one numbered item per step.</p>

<h3 id="Text_formatting_and_styles">Text formatting and styles</h3>

<p>Use the <strong>"Formatting Styles"</strong> drop-down list to apply predefined styles to selected content.</p>

<div class="note">The <strong>"Note Box"</strong> style is used to call out important notes, like this one.</div>

<div class="warning">Similarly, the <strong>"Warning Box"</strong> style creates warning boxes like this.</div>

<p>Unless specifically instructed, <em>do not</em> use the HTML <code>style</code> attribute to manually apply a style. If you can't do it using a predefined class, ask for help in the <a href="https://discourse.mozilla.org/c/mdn">MDN discussion forum</a>.</p>

<h3 id="Code_sample_style_and_formatting">Code sample style and formatting</h3>

<div class="note">
<p><strong>Note</strong>: This section deals with the styling/formatting of code as it appears on an MDN article. If you want guidelines on actually writing code examples, see our <a href="/en-US/docs/MDN/Contribute/Guidelines/Code_samples">Code sample guidelines</a>.</p>
</div>

<h4 id="Tabs_and_line_breaks">Tabs and line breaks</h4>

<p>Use two spaces per tab in all code examples. Indent the code cleanly, with open-brace ("<code>{</code>") characters on the same line as the statement that opens the block. For example:</p>

<pre class="brush: js notranslate">if (condition) {
  /* handle the condition */
} else {
  /* handle the "else" case */
}
</pre>

<p>Long lines shouldn't be allowed to stretch off horizontally to the extent that they require horizontal scrolling to read. Instead, break long lines at natural breaking points. Some examples follow:</p>

<pre class="brush: js notranslate">if (class.CONDITION || class.OTHER_CONDITION || class.SOME_OTHER_CONDITION
       || class.YET_ANOTHER_CONDITION ) {
  /* something */
}

var toolkitProfileService = Components.classes["@mozilla.org/toolkit/profile-service;1"]
                           .createInstance(Components.interfaces.nsIToolkitProfileService);
</pre>

<h4 id="Inline_code_formatting">Inline code formatting</h4>

<p>Use the "Code" button (labeled with two angle brackets "<strong>&lt;&gt;</strong>") to apply inline code-style formatting to function names, variable names, and method names. (This uses the {{HTMLElement("code")}} element). For example: "the <code class="js plain">frenchText()</code> function".</p>

<p><strong>Method names should be followed by a pair of parentheses.</strong> For example, <code>doSomethingUseful()</code>. The parentheses help differentiate methods from other code terms.</p>

<h4 id="Syntax_highlighting">Syntax highlighting</h4>

<p><img alt="Screenshot of the 'Syntax Highlighter' menu." src="https://mdn.mozillademos.org/files/12682/Language%20list.png" style="border-style: solid; border-width: 1px; float: right; margin: 2px 4px;">A line or multiple lines of code should be formatted using syntax highlighting rather than the {{HTMLElement("code")}} element. Select the appropriate language from the language list button (the one with the two code blocks), as seen in the screenshot to the right. This will insert a preformatted code box with line numbers and syntax highlighting for the chosen language.</p>

<div class="note">
<p><strong>Note:</strong> <em>Do not</em> use the {{HTMLElement("code")}} element inside the {{HTMLElement("pre")}} block!</p>

<p>While this structure is used on some sites, we do not do so on MDN; nesting these elements will break certain aspects of our styling.</p>
</div>

<p>The following example shows text with JavaScript formatting:</p>

<div class="line number2 index1 alt1">
<pre class="brush: js notranslate">for (let i = 0, j = 9; i &lt;= 9; i++, j--)
  document.writeln("a[" + i + "][" + j + "]= " + a[i][j]);</pre>
</div>

<p>If no appropriate language is available, use ("No Highlight" in the language menu). This will result in code without syntax highlighting:</p>

<pre class="brush: plain notranslate">x = 42;</pre>

<h4 id="Syntax_definitions">Syntax definitions</h4>

<p>When writing the syntax description section of a reference page, use the <em>"Syntax Box"</em> option in the <strong>"Styles"</strong> drop-down menu in the editor toolbar. This creates a specially-formatted box that is used specifically for syntax definitions, distinguishing them from other code blocks.</p>

<h4 id="Blocks_not_referring_to_code">Blocks not referring to code</h4>

<p>There are a some use cases where a <code>&lt;pre&gt;</code> block does not refer to code and doesn't have syntax highlighting nor line numbers. In such cases you should add a <code>&lt;pre&gt;</code> without a <code>class</code> attribute. For example, those cases include tree structures:</p>

<pre class="notranslate">root/

  folder1/
    file1

  folder2/
    file2
    file3
</pre>

<p>To create preformatted content without syntax highlighting and line numbers click the "<strong>PRE</strong>" button in the toolbar. Then start to type the text.</p>

<h4 id="Styling_mentions_of_HTML_elements">Styling mentions of HTML elements</h4>

<p>There are specific rules to follow when writing about HTML elements. These rules produce consistent descriptions of elements and their components. They also ensure correct linking to detailed documentation.</p>

<dl>
 <dt>Element names</dt>
 <dd>Use the {{TemplateLink("HTMLElement")}} macro, which creates a link to the page for that element. For example, writing \{{HTMLElement("title")}} produces "{{HTMLElement("title")}}". If you don't want to create a link, <strong>enclose the name in angle brackets</strong> and use the "Inline Code" style (e.g., <code>&lt;title&gt;</code>).</dd>
 <dt>Attribute names</dt>
 <dd>Use "Inline Code" style to put attribute names in <code>code font</code>. Additionally, put them in <strong><code>bold face</code></strong> when the attribute is mentioned in association with an explanation of what it does, or the first time it is used in the article.</dd>
 <dt>Attribute definitions</dt>
 <dd>Use the {{TemplateLink("htmlattrdef")}} macro (e.g., <span class="nowiki">\{{htmlattrdef("type")}}</span>) for the definition term, so that it can be linked to from other pages easily by using the {{TemplateLink("htmlattrxref")}} macro (e.g., <span class="nowiki">\{{htmlattrxref("type","element")}}</span>) to reference attribute definitions.</dd>
 <dt>Attribute values</dt>
 <dd>Use the "Inline Code" style to apply <code>&lt;code&gt;</code> to attribute values, and don't use quotation marks around string values, unless needed by the syntax of a code sample.</dd>
 <dd><strong>For example:</strong> "When the <code>type</code> attribute of an <code>&lt;input&gt;</code> element is set to <code>email</code> or <code>tel</code> ..."</dd>
</dl>

<h3 id="Latin_abbreviations">Latin abbreviations</h3>

<h4 id="In_notes_and_parentheses">In notes and parentheses</h4>

<ul>
 <li>Common Latin abbreviations (etc., i.e., e.g.) may be used in parenthetical expressions and notes. Use periods in these abbreviations, followed by a comma or other appropriate punctuation.
  <ul>
   <li><span class="correct"><strong>Correct</strong></span>: Web browsers (e.g., Firefox) can be used ...</li>
   <li><span class="incorrect"><strong>Incorrect</strong></span>: Web browsers e.g. Firefox can be used ...</li>
   <li><span class="incorrect"><strong>Incorrect</strong></span>: Web browsers, e.g. Firefox, can be used ...</li>
   <li><span class="incorrect"><strong>Incorrect</strong></span>: Web browsers, (eg: Firefox) can be used ...</li>
  </ul>
 </li>
</ul>

<h4 id="In_running_text">In running text</h4>

<ul>
 <li>In regular text (i.e., text outside of notes or parentheses), use the English equivalent of the abbreviation.
  <ul>
   <li><span class="correct"><strong>Correct</strong></span>: ... web browsers, and so on.</li>
   <li><span class="incorrect"><strong>Incorrect</strong></span>: ... web browsers, etc.</li>
   <li><span class="correct"><strong>Correct</strong></span>: Web browsers such as Firefox can be used ...</li>
   <li><span class="incorrect"><strong>Incorrect</strong></span>: Web browsers e.g. Firefox can be used ...</li>
  </ul>
 </li>
</ul>

<h4 id="Meanings_and_English_equivalents_of_Latin_abbreviations">Meanings and English equivalents of Latin abbreviations</h4>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Abbrev</th>
   <th scope="col">Latin</th>
   <th scope="col">English</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>cf.</td>
   <td><em>confer</em></td>
   <td>compare</td>
  </tr>
  <tr>
   <td>e.g.</td>
   <td><em>exempli gratia</em></td>
   <td>for example</td>
  </tr>
  <tr>
   <td>et al.</td>
   <td><em>et alii</em></td>
   <td>and others</td>
  </tr>
  <tr>
   <td>etc.</td>
   <td><em>et cetera</em></td>
   <td>and so forth, and so on</td>
  </tr>
  <tr>
   <td>i.e.</td>
   <td><em>id est</em></td>
   <td>that is, in other words</td>
  </tr>
  <tr>
   <td>N.B.</td>
   <td><em>nota bene</em></td>
   <td>note well</td>
  </tr>
  <tr>
   <td>P.S.</td>
   <td><em>post scriptum</em></td>
   <td>postscript</td>
  </tr>
 </tbody>
</table>

<div class="note">
<p>Always consider whether it's truly beneficial to use a Latin abbreviation. Some of these are used so rarely that many readers won't understand the meaning, and others are often confused with one another.</p>

<p>Also, be sure that <em>you</em> use them correctly, if you choose to do so. For example, be careful not to confuse "e.g." with "i.e.", which is a common error.</p>
</div>

<h3 id="Acronyms_and_abbreviations">Acronyms and abbreviations</h3>

<h4 id="Capitalization_and_periods">Capitalization and periods</h4>

<p>Use full capitals and delete periods in all acronyms and abbreviations, including organizations such as "US" and "UN".</p>

<ul>
 <li><span class="correct"><strong>Correct</strong></span>: XUL</li>
 <li><span class="incorrect"><strong>Incorrect</strong></span>: X.U.L.; Xul</li>
</ul>

<h4 id="Expansion">Expansion</h4>

<p>On the first mention of a term on a page, expand acronyms that are likely to be unfamiliar to users. When in doubt, expand it—or better yet, link it to the article or <a href="/en-US/docs/Glossary">glossary</a> entry describing the technology.</p>

<ul>
 <li><span class="correct"><strong>Correct</strong></span>: "XUL (XML User Interface Language) is Mozilla's XML-based language..."</li>
 <li><span class="incorrect"><strong>Incorrect</strong></span>: "XUL is Mozilla's XML-based language..."</li>
</ul>

<h4 id="Plurals_of_acronyms_and_abbreviations">Plurals of acronyms and abbreviations</h4>

<p>For plurals of acronyms or abbreviations, add <em>s</em>.</p>

<p>Don't use an apostrophe. Ever. Please.</p>

<ul>
 <li><span class="correct"><strong>Correct</strong></span>: CD-ROMs</li>
 <li><span class="incorrect"><strong>Incorrect</strong></span>: CD-ROM's</li>
</ul>

<h4 id="Versus_vs._and_v.">"Versus", "vs.", and "v."</h4>

<p>The contraction "vs." is preferred.</p>

<ul>
 <li><span class="correct"><strong>Correct</strong></span>: this vs. that</li>
 <li><span class="incorrect"><strong>Incorrect</strong></span>: this v. that</li>
 <li><span class="incorrect"><strong>Incorrect</strong></span>: this versus that</li>
</ul>

<h3 id="Capitalization">Capitalization</h3>

<p>Use standard English capitalization rules in body text, and capitalize "World Wide Web." It is acceptable to use lower case for "web" (used alone or as a modifier) and "internet".</p>

<div class="notecard note">
<p>This guideline is a change from a previous version of this guide, so you may find many instances of "Web" and "Internet" on MDN.</p>

<p>Feel free to change these as you are making other changes, but editing an article just to change capitalization is not necessary.</p>
</div>

<p>Keyboard keys should use sentence-style capitalization, not all-caps capitalization. For example, "<kbd>Enter</kbd>" not "<kbd>ENTER</kbd>". The only exception is that you can use "<kbd>ESC</kbd>" to abbreviate he "<kbd>Escape</kbd>" key.</p>

<p>Certain words should always be capitalized (such as trademarks which include capital letters), or words derived from the name of a person (unless it's being used within code, and code’s syntax requires lower-casing). Some examples:</p>

<ul>
 <li>Boolean (named for English mathematician and logician {{interwiki("wikipedia", "George Boole")}})</li>
 <li>JavaScript (a trademark of Oracle Corporation, it should always be written as trademarked)</li>
 <li>Python, TypeScript, Django, and other programming languages and framework names</li>
</ul>

<h3 id="Contractions">Contractions</h3>

<p>Our writing style tends to be casual, so you should feel free to use contractions (e.g., "don't", "can't", "shouldn't"), if you prefer.</p>

<h3 id="Pluralization">Pluralization</h3>

<p>Use English-style plurals, not the Latin- or Greek-influenced forms.</p>

<ul>
 <li><span class="correct"><strong>Correct</strong></span>: syllabuses, octopuses</li>
 <li><span class="incorrect"><strong>Incorrect</strong></span>: syllabi, octopi</li>
</ul>

<h3 id="Hyphenation">Hyphenation</h3>

<p>Hyphenate compounds should be used when the last letter of the prefix is a vowel and is the same as the first letter of the root.</p>

<ul>
 <li><font color="green"><strong>Correct</strong></font>: email, re-elect, co-op</li>
 <li><font color="red"><strong>Incorrect</strong></font>: e-mail, reelect, coop</li>
</ul>

<h3 id="Gender-neutral_language">Gender-neutral language</h3>

<p>To make the text as inclusive as possible, it is best to use gender-neutral language in any writing where gender is irrelevant to the subject matter. For example, if you are talking about the actions of a specific man, using "he"/"his" is fine; but if the subject is a person of either gender, "he"/"his" isn't appropriate.<br>
 <br>
 Let's take the following example:</p>

<blockquote>
<p>A confirmation dialog appears, asking the user if he allows the Web page to make use of his Web cam.</p>
</blockquote>

<blockquote>
<p>A confirmation dialog appears, asking the user if she allows the Web page to make use of her Web cam.</p>
</blockquote>

<p>Both versions are gender-specific. To fix this, use gender-neutral pronouns:</p>

<blockquote>
<p>A confirmation dialog appears, asking the user if they allow the Web page to make use of their Web cam.</p>
</blockquote>

<div class="note">
<p>MDN allows the use of this very common syntax (which is controversial among usage authorities) to make up for the lack of a neutral gender in English.</p>

<p>The use of the third-person plural as a gender neutral pronoun (that is, using "they," "them", "their," and "theirs") is an accepted practice, commonly known as "<a href="https://en.wikipedia.org/wiki/Singular_they">singular 'they.'</a>"</p>
</div>

<p>You can use both genders:</p>

<blockquote>
<p>A confirmation dialog appears, asking the user if he or she allows the web page to make use of his/her web cam.</p>
</blockquote>

<p>Making the users plural:</p>

<blockquote>
<p>A confirmation dialog appears, asking the users if they allow the web page to make use of their web cams.</p>
</blockquote>

<p>The best solution, of course, is to rewrite and eliminate the pronouns:</p>

<blockquote>
<p>A confirmation dialog appears, requesting the user's permission for web cam access.</p>
</blockquote>

<blockquote>
<p>A confirmation dialog box appears, which asks the user for permission to use the web cam.</p>
</blockquote>

<p>This last example of dealing with the problem is arguably better. Not only is it grammatically more correct, but removes some of the complexity associated with dealing with genders across different languages that may have wildly different gender rules. This solution can make translation easier for both readers and localizers.</p>

<h3 id="Numbers_and_numerals">Numbers and numerals</h3>

<h4 id="Dates">Dates</h4>

<p>For dates (not including dates in code samples) use the format "January 1, 1990".</p>

<ul>
 <li><span class="correct"><strong>Correct</strong></span>: February 24, 2006</li>
 <li><span class="incorrect"><strong>Incorrect</strong></span>: February 24th, 2006; 24 February, 2006; 24/02/2006</li>
</ul>

<p>Alternately, you can use the YYYY/MM/DD format.</p>

<ul>
 <li><span class="correct"><strong>Correct</strong></span>: 2006/02/24</li>
 <li><span class="incorrect"><strong>Incorrect</strong></span>: 02/24/2006; 24/02/2006; 02/24/06</li>
</ul>

<h4 id="Decades">Decades</h4>

<p>For decades, use the format "1990s". Don't use an apostrophe.</p>

<ul>
 <li><span class="correct"><strong>Correct</strong></span>: 1990s</li>
 <li><span class="incorrect"><strong>Incorrect</strong></span>: 1990's</li>
</ul>

<h4 id="Plurals_of_numerals">Plurals of numerals</h4>

<p>For plurals of numerals add "s". Don't use an apostrophe.</p>

<ul>
 <li><span class="correct"><strong>Correct</strong></span>: 486s</li>
 <li><span class="incorrect"><strong>Incorrect</strong></span>: 486's</li>
</ul>

<h4 id="Commas">Commas</h4>

<p>In running text, use commas only in five-digit and larger numbers.</p>

<ul>
 <li><span class="correct"><strong>Correct</strong></span>: 4000; 54,000</li>
 <li><span class="incorrect"><strong>Incorrect</strong></span>: 4,000; 54000</li>
</ul>

<h3 id="Punctuation">Punctuation</h3>

<h4 id="Serial_comma">Serial comma</h4>

<p><strong>Use the serial comma</strong>. The serial (also known as "Oxford") comma is the comma that appears before the conjunction in a series of three or more items.</p>

<ul>
 <li><span class="correct"><strong>Correct</strong></span>: I will travel on trains, planes, and automobiles.</li>
 <li><span class="incorrect"><strong>Incorrect</strong></span>: I will travel on trains, planes and automobiles.</li>
</ul>

<div class="note">
<p>This is in contrast to the <a href="https://www.mozilla.org/en-US/styleguide/">One Mozilla style guide</a>, which specifies that the serial comma is not to be used. MDN is an exception to this rule.</p>
</div>

<h4 id="Apostrophes_and_quotation_marks">Apostrophes and quotation marks</h4>

<p><strong>Do not use "curly" quotes and quotation marks.</strong> On MDN, we only use straight quotes and apostrophes.</p>

<p>There are a couple of reasons for this.</p>

<ol>
 <li>We need to choose one or the other for consistency.</li>
 <li>If curly quotes or apostrophes make their way into code snippets—even inline ones—readers may copy and paste them, expecting them to function (which they will not).</li>
</ol>

<ul>
 <li><span class="correct"><strong>Correct</strong></span>: Please don't use "curly quotes."</li>
 <li><span class="incorrect"><strong>Incorrect</strong></span>: Please don’t use “curly quotes.”</li>
</ul>

<h3 id="Spelling">Spelling</h3>

<p>For words with variant spellings, always use their American English spelling.</p>

<p>In general, use the first entry at <a href="http://www.dictionary.com/">Dictionary.com</a>, unless that entry is listed as a variant spelling or as being primarily used in a non-American form of English. For example, if you <a href="http://www.dictionary.com/browse/behaviour">look up "behaviour"</a>, you find the phrase "Chiefly British" followed by a link to the American standard form, "<a href="http://dictionary.reference.com/browse/behavior">behavior</a>". Do not use variant spellings.</p>

<ul>
 <li><span class="correct"><strong>Correct</strong></span>: localize, behavior</li>
 <li><span class="incorrect"><strong>Incorrect</strong></span>: localise, behaviour</li>
</ul>

<h3 id="Terminology">Terminology</h3>

<h4 id="HTML_elements">HTML elements</h4>

<p>Use "elements" to refer to HTML and XML elements, rather than "tags". In addition, they should almost always be wrapped in "&lt;&gt;", and should be in the {{HTMLElement("code")}} style.</p>

<p>When you reference a given element for the first time in a section, you should use the {{TemplateLink("HTMLElement")}} macro to create a link to the documentation for the element (unless you're writing within that element's reference document page).</p>

<ul>
 <li><span class="correct"><strong>Correct</strong></span>: the {{HTMLElement("span")}} element</li>
 <li><span class="incorrect"><strong>Incorrect</strong></span>: the span tag</li>
</ul>

<h4 id="Parameters_vs._arguments">Parameters vs. arguments</h4>

<p>The preferred term on MDN is <strong>parameters</strong>. Please avoid the term "arguments" for consistency whenever possible.</p>

<h4 id="User_interface_actions">User interface actions</h4>

<p>In task sequences, describe user interface actions using the imperative mood. Identify the user interface element by its label and type.</p>

<ul>
 <li><span class="correct"><strong>Correct</strong></span>: Click the Edit button.</li>
 <li><span class="incorrect"><strong>Incorrect</strong></span>: Click Edit.</li>
</ul>

<h3 id="Voice">Voice</h3>

<p>While the active voice is preferred, the passive voice is also acceptable, given the informal feel of our content. Try to be consistent, though.</p>

<h2 id="Wiki_markup_and_usage">Wiki markup and usage</h2>

<h3 id="Links">Links</h3>

<p>Links are a large part of what makes a wiki a powerful learning and teaching tool. Below you'll find some basic information, but you can find a complete guide to <a href="/en-US/docs/MDN/Contribute/Editor/Links">creating and editing links on MDN</a> in our editor guide.</p>

<p>We encourage you to create appropriate links among articles; they help improve navigation and discoverability of content, and they provide important context to search engines like Google to help them provide better results. Every page should have a good set of links from words or phrases to other pages that expand upon the relevant ideas. This can be used both to define terms and to provide more in-depth or detailed documentation about a topic, or to connect to a related page that offers examples or information that may be of further interest.</p>

<p>You can easily create links not only among pages on MDN (internal links) but also to pages outside MDN (external links).</p>

<p>There are two ways to create links:</p>

<ul>
 <li>You explicitly create a link using the Link button in the editor's toolbar—or by pressing <kbd>Ctrl</kbd>+<kbd>K</kbd> (<kbd>Cmd</kbd>+<kbd>K</kbd> on the Mac).</li>
 <li>Or, you can use MDN's powerful macro system to generate links automatically or based on an input value.</li>
</ul>

<p>When deciding what text to use as a link, there are a few guidelines you can follow:</p>

<ul>
 <li><strong>Whenever a macro exists which will create the link you need, and you are able to do so, please do.</strong> <a href="/en-US/docs/MDN/Contribute/Editor/Links#Using_link_macros">Using macros to create links</a> will not only help you get it right, but will allow future improvements to MDN to automatically be applied to your link.</li>
 <li><strong>For an API name, use the entire string of the API term as written in your content.</strong> The easiest way to do this is to <a href="/en-US/docs/MDN/Contribute/Editor/Links#Linking_to_documentation_for_APIs">use the appropriate macro</a> to construct a properly-formatted link for you.</li>
 <li>To link to a page defining or discussing a particular term, use <em>only</em> the term's name for the link's text; do not include additional text in the link. For example:
  <ul>
   <li><span class="correct"><strong>Correct</strong></span>: You can use <a href="/en-US/docs/Web/JavaScript">JavaScript</a> code to create dynamic applications on the Web.</li>
   <li><span class="incorrect"><strong>Incorrect</strong></span>: You can use <a href="/en-US/docs/Web/JavaScript">JavaScript code</a> to create dynamic applications on the Web.</li>
  </ul>
 </li>
 <li>Otherwise, when adding a useful link to prose, try to choose an action and object phrase, such as:
  <ul>
   <li><span class="correct"><strong>Correct</strong></span>: If you'd like to <a href="/en-US/docs/Mozilla/Developer_guide">contribute to the Firefox project</a>, your first step is to <a href="/en-US/docs/Mozilla/Developer_guide/Build_Instructions">download and build Firefox</a>.</li>
   <li><span class="incorrect"><strong>Incorrect</strong></span>: <a href="/en-US/docs/Mozilla/Developer_guide">If you'd like to contribute to the Firefox project</a>, your first step is to <a href="/en-US/docs/Mozilla/Developer_guide/Build_Instructions">download and build</a> Firefox.</li>
  </ul>
 </li>
</ul>

<h4 id="URL_schemes">URL schemes</h4>

<p>For security reasons, you should only create links that use the following schemes:</p>

<ul>
 <li><code>http://</code></li>
 <li><code>https://</code></li>
 <li><code>ftp://</code></li>
 <li><code>mailto:</code></li>
</ul>

<p>Others may or may not work, but are not supported and will probably be removed by editorial staff.</p>

<div class="note">
<p>In particular, avoid the <code>about:</code> or <code>chrome://</code> schemes, as they will not work.</p>

<p>Similarly, the <code>javascript:</code> scheme is blocked by most modern browsers, as is <code>jar:</code>.</p>
</div>

<h3 id="Page_tags">Page tags</h3>

<p>Tags provide meta information about a page. They may also indicate that a page has specific improvements needed to its content. Every page in the wiki should have tags.</p>

<p>You can find details on tagging in our <a href="/en-US/docs/MDN/Contribute/Howto/Tag">How to properly tag pages</a> guide.</p>

<p>The tagging interface lives at the bottom of a page while you're in edit mode, and looks something like this:</p>

<p><img alt="Screenshot of the UX for adding and removing tags on MDN" src="https://mdn.mozillademos.org/files/7859/tag-interface.png" style="border-style: solid; border-width: 1px; height: 167px; width: 863px;"></p>

<p>To add a tag, click in the edit box at the end of the tag list and type the tag name you wish to add. Tags will autocomplete as you type. Press <kbd>Enter</kbd> (or <kbd>Return</kbd>) to submit the new tag. Each article may have as many tags as needed. For example, an article about using JavaScript in AJAX programming might have both "JavaScript" and "AJAX" as tags.</p>

<p>To remove a tag, just click the little "<code>×</code>" icon in the tag.</p>

<h4 id="Tagging_pages_that_need_work">Tagging pages that need work</h4>

<p>In addition to using tags to track information about the documentation's quality and content, we also use them to mark articles as needing specific types of work.</p>

<h4 id="Tagging_obsolete_pages">Tagging obsolete pages</h4>

<p>Use the following tags for pages that are not current:</p>

<dl>
 <dt>Junk</dt>
 <dd>Use for spam, pages created by mistake, or content that is so bad that it should be deleted. Pages with this tag are deleted from time to time.</dd>
 <dt>Obsolete</dt>
 <dd>
 <p>Use for content that is technically superseded, but still valid in context. For example, this might be an HTML element that is obsolete in HTML5, but still valid in HTML 4.01.</p>

 <p>You can also use the <span class="nowiki">{{TemplateLink("obsolete_header")}}</span> macro to put a prominent banner on the topic.</p>
 </dd>
 <dt>Archive</dt>
 <dd>
 <p>Use for content that is technically superseded and no longer useful. If possible, add a note to the topic referring readers to a more current topic.</p>

 <p>For example, a page that describes how to use the Mozilla CVS repository should refer readers to a current topic on using Mercurial repos. (If no corresponding current topic exists, use the <em>NeedsUpdate</em> tag, and add an explanation on the Talk page.)</p>

 <p>Pages with the <em>Archive</em> tag are eventually moved from the main content of MDN to the <a href="/en-US/docs/Archive">Archive</a> section.</p>
 </dd>
</dl>

<h3 id="SEO_summary">SEO summary</h3>

<p>The SEO summary provides a short description of a page. It will be reported as a summary of the article to robots crawling the site, and will then appear in search results for the page. It is also used by macros that automate the construction of landing pages inside MDN itself. (In other words, it's not just for SEO.)</p>

<p>By default, the first paragraph of the page is used as the SEO summary. However, you can override this behavior by marking a section with the <a href="/en-US/docs/Project:MDN/Contributing/Editor_guide/Editing#Formatting_styles">"SEO summary" style in the WYSIWYG editor</a>.</p>

<h3 id="Landing_pages">Landing pages</h3>

<p><strong>Landing pages</strong> are pages at the root of a topic area of the site, such as the main <a href="/en-US/docs/CSS" title="CSS">CSS</a> or <a href="/en-US/docs/HTML" title="HTML">HTML</a> pages. They have a standard format that consists of three areas:</p>

<ol>
 <li>A brief overview (typically one paragraph) of what the technology is and how it's used. See {{anch("Writing a landing page overview")}} for tips.</li>
 <li>A two-column list of links with appropriate headings. See {{anch("Creating a page link list")}} for guidelines.</li>
 <li>An <strong>optional</strong> "Browser compatibility" section at the bottom of the page.</li>
</ol>

<h4 id="Creating_a_page_link_list">Creating a page link list</h4>

<p>The link list section of an MDN landing page consists of two columns. These are created using the following HTML:</p>

<pre class="brush: html notranslate">&lt;div class="row topicpage-table"&gt;
  &lt;div class="section"&gt;
    ... left column contents ...
  &lt;/div&gt;
  &lt;div class="section"&gt;
    ... right column contents ...
  &lt;/div&gt;
&lt;/div&gt;</pre>

<p>The left column should be a list of articles, with an <code>&lt;h2&gt;</code> header at the top of the left column explaining that it's a list of articles about the topic (e.g., "Documentation and tutorials about foo"). This header should use the CSS class "Documentation".</p>

<p>Below that is a <code>&lt;dl&gt;</code> list of articles with each article's link in a <code>&lt;dt&gt;</code> block and a brief one-or-two sentence summary of the article in the corresponding <code>&lt;dd&gt;</code> block.</p>

<p>The right column should contain one or more of the following sections, in order:</p>

<dl>
 <dt>Getting help from the community</dt>
 <dd>This should provide information on Matrix chat rooms and mailing lists available on the topic. The heading should use the class "<code>Community</code>".</dd>
 <dt>Tools</dt>
 <dd>A list of tools the user can look at to help with the use of the technology described in this section of MDN. The heading should use the class "<code>Tools</code>".</dd>
 <dt>Related topics</dt>
 <dd>A list of links to landing pages for other, related, technologies of relevance. The heading should use the class "<code>Related_Topics</code>".</dd>
</dl>

<p><strong>{{TODO("Finish this once we finalize the landing page standards")}}</strong></p>

<h2 id="Using_and_inserting_images">Using and inserting images</h2>

<p>It's sometimes helpful to provide an image in an article you create or modify, especially if the article is very technical.</p>

<p>To include an image:</p>

<ol>
 <li>Before uploading your image, please ensure that it's as small as possible by using an image optiization tool.
  <ul>
   <li>For bitmap images (JPG or PNG), consider a tool such as <a href="https://imageoptim.com/mac">ImageOptim</a> (macOS), <a href="https://tinypng.com/">TinyPNG</a> (web service), or <a href="https://trimage.org/">Trimage</a> (Linux).</li>
   <li>For SVG images, use the <code><a href="https://github.com/svg/svgo">svgo</a></code> tool to optimize the SVG file before sending it. The default configuration is fine.</li>
  </ul>
 </li>
 <li>Attach the desired image file to the article (at the bottom of every article in edit mode). If your artwork is a diagram in SVG format (which is ideal if there is text that may need to be localized), you can't upload it directly, but you can ask an MDN admin to do it for you.</li>
 <li>Click the "<strong>insert image</strong>" button in the MDN documentation WYSIWYG editor.</li>
 <li>In the WYSIWYG editor's drop-down list of attachments, select the newly created attachment that is your image.</li>
 <li>Press the <strong>OK</strong> button.</li>
</ol>

<div class="warning">
<p><strong>Important:</strong> Remember to save any changes you've made before uploading an attachment to your article! The editor is closed during the upload process, and currently <em>does not verify</em> whether or not you wish to save your work when it does so.</p>
</div>

<h2 id="Other_references">Other references</h2>

<h3 id="Preferred_style_guides">Preferred style guides</h3>

<p>If you have questions about usage and style not covered here, we recommend referring to the <a href="https://docs.microsoft.com/en-us/style-guide/welcome/">Microsoft Writing Style Guide</a>—or, failing that, the <a href="https://www.amazon.com/Chicago-Manual-Style-16th/dp/0226104206">Chicago Manual of Style</a>. An <a href="https://faculty.cascadia.edu/cma/HIST148/cmscrib.pdf">unofficial crib sheet for the Chicago Manual of Style</a> is available online.</p>

<h3 id="Preferred_dictionary">Preferred dictionary</h3>

<p>For questions of spelling, please refer to <a href="http://www.dictionary.com/">Dictionary.com</a>. The spelling checker for this site uses American English. Please do not use variant spellings (e.g., use <em>color</em> rather than <em>colour</em>).</p>

<p>We will be expanding the guide over time, so if you have specific questions that aren't covered in this document, please post them on the <a href="https://discourse.mozilla.org/c/mdn">MDN discussion forum</a>, so we know what should be added.</p>

<h3 id="MDN-specific">MDN-specific</h3>

<ul>
 <li><a href="/en-US/docs/MDN/Contribute/Structures/Macros/Commonly-used_macros" title="Project:en/Custom_Templates">Commonly-used macros</a> on MDN, with explanations</li>
</ul>

<h3 id="Language_grammar_spelling">Language, grammar, spelling</h3>

<p>If you're interested in improving your writing and editing skills, you may find the following resources to be helpful.</p>

<ul>
 <li><a href="http://www.amazon.com/Writing-Well-30th-Anniversary-Nonfiction/dp/0060891548">On Writing Well</a>, by William Zinsser (Amazon link)</li>
 <li><a href="http://www.amazon.com/Style-Basics-Clarity-Grace-4th/dp/0205830765/" title="http://www.amazon.com/Style-Lessons-Clarity-Grace-Edition/dp/0321898680">Style: The Basics of Clarity and Grace</a>, by Joseph Williams and Gregory Colomb (Amazon link)</li>
 <li><a href="https://brians.wsu.edu/common-errors-in-english-usage/">Common Errors in English</a></li>
 <li><a href="http://www-personal.umich.edu/~jlawler/aue.html">English Grammar FAQ</a> (alt.usage.english)</li>
 <li><a href="http://www.angryflower.com/bobsqu.gif">Bob's quick guide to the apostrophe, you idiots</a> (funny)</li>
 <li><a href="http://www.amazon.com/Merriam-Websters-Concise-Dictionary-English-Usage/dp/B004L2KNI2">Merriam-Webster's Concise Dictionary of English Usage</a> (Amazon link): Scholarly but user-friendly, evidence-based advice; very good for non-native speakers, especially for preposition usage.</li>
 <li><a href="http://english.stackexchange.com/">English Language and Usage StackExchange</a>: Question and answer site for English language usage.</li>
</ul>
